/* samDbDispActionn: display DB Action	program					*/
/* Copyright (c) 2004-2005 yma system lab. All rights reserved.	*/

package action;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.commons.logging.*;

import java.util.*;
import action.form.*;
import model.*;
import yscsoltp.yswebsvr.*;

public class samDbDispAction extends Action {
	private	Log 	 log	= LogFactory.getLog(getClass());
	private static final int dispRecd	= 16;

    public ActionForward execute(
              ActionMapping mapping, ActionForm form,
              HttpServletRequest req, HttpServletResponse res) throws Exception {

		yswebSession mysess	 = yswebGetSession.get(req);
		sampleForm samForm = (sampleForm)form;
		samDbDisp	dbdisp	= new samDbDisp();

		if (mysess == null) {
			log.info("yswebUserDispAction:execute() yswebSession null");
	        return mapping.findForward(samConst.ERROR);
		}
		String sql = samForm.getValue("sqlText");		/* sql擾		*/
		String key = samForm.getValue("sqlCmd");		/* wR}h		*/
		if (key != null) {
			if (key.equals("M")) {					/* M{^		*/
				if (dbdisp.dispPage(mysess, sql, dispRecd) != 0) {
					log.error("dbDisp error!!");
					setErrorMsg(req);
				}
			}
			else if (key.equals("")) dbdisp.nextPage(mysess, dispRecd);
			else if (key.equals("߂")) dbdisp.backPage(mysess, dispRecd);
			else if (key.equals("XV")) dbdisp.dispPage(mysess, null, dispRecd);
		}
		yswebGetSession.free(mysess);
        return mapping.findForward(samConst.SUCCESS);
	}
	private void setErrorMsg(HttpServletRequest req) {
		ActionMessages msgs = new ActionMessages();	/* CX^X̎擾		*/
		msgs.add(ActionMessages.GLOBAL_MESSAGE,
				new ActionMessage("dbDisp_failed"));/* \[Xt@C̗p	*/
		saveErrors(req, msgs);						/* G[bZ[W̓o^	*/
	}
}
