/* samDbUpdateAction: update DB Action program				*/
/* Copyright (c) 2004-2005 yma system lab. All rights reserved.	*/

package action;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.commons.logging.*;

import java.util.*;
import action.form.*;
import model.*;
import yscsoltp.yswebsvr.*;

public class samDbUpdateAction extends Action {
	private	Log 	 log	= LogFactory.getLog(getClass());
	private static final int dispRecd	= 14;

    public ActionForward execute(
              ActionMapping mapping, ActionForm form,
              HttpServletRequest req, HttpServletResponse res) throws Exception {

		yswebSession mysess	 = 	yswebGetSession.get(req);
		sampleForm samForm 	= (sampleForm)form;
		samDbDisp		dbdisp		= new samDbDisp();
		samDbUpdate		dbupdate	= new samDbUpdate();
		String			forward		= samConst.SUCCESS;
		if (mysess == null) {
			log.info("yswebUserupdateAction:execute() yswebSession null");
	        return mapping.findForward(samConst.ERROR);
		}
		String cmd = samForm.getValue("sqlCmd");

		if (cmd != null) {
			if (cmd.equals("M")) {
				String sql = samForm.getValue("tblName");
				if (!sql.toUpperCase().substring(0,6).equals("SELECT")) {
					sql = "SELECT * FROM " + sql;
				}
				if (dbdisp.dispPage(mysess, sql, dispRecd) != 0) {
					log.error("dbDisp error!!");
					setErrorMsg(req);
				}
			}
			else if (cmd.equals("")) dbdisp.nextPage(mysess, dispRecd);
			else if (cmd.equals("߂")) dbdisp.backPage(mysess, dispRecd);
			else if (cmd.equals("ύX")) {
				if (dbupdate.makeUpData(mysess, samForm.getValue()) != 0) {
					log.error("makeUpData error!!");
					setErrorMsg(req);
				}
				forward = samConst.RESULT;
			}
			else if (cmd.equals("m")) {
				if (dbupdate.dbUpdate(mysess, samForm.getValue()) != 0) {
					log.error("dbUpdate error!!");
					setErrorMsg(req);
				}
				dbdisp.dispPage(mysess, null, dispRecd);
			}
			else if (cmd.equals("~")) dbdisp.dispPage(mysess, null, dispRecd);
			else if (cmd.equals("ǉ")) {
				dbupdate.initInsert(mysess);
				forward = samConst.INSERT;
			}
			else if (cmd.equals("o^")) {
				if (dbupdate.dbInsert(mysess, samForm.getValue()) != 0) {
					log.error("dbInsert error!!");
					setErrorMsg(req);
				}
				dbupdate.initInsert(mysess);
				forward = samConst.INSERT;
			}
		}
		yswebGetSession.free(mysess);
        return mapping.findForward(forward);
	}
	private void setErrorMsg(HttpServletRequest req) {
		ActionMessages msgs = new ActionMessages();	/* CX^X̎擾		*/
		msgs.add(ActionMessages.GLOBAL_MESSAGE,
				new ActionMessage("dbDisp_failed"));/* \[Xt@C̗p	*/
		saveErrors(req, msgs);						/* G[bZ[W̓o^	*/
	}
}
