/* samEchoAction: echo Action program							*/
/* Copyright (c) 2004-2005 yma system lab. All rights reserved.	*/

package action;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.commons.logging.*;

import action.form.*;
import model.*;
import yscsoltp.yswebsvr.*;

public class samEchoAction extends Action {
	private	Log 	 log	= LogFactory.getLog(getClass());

    public ActionForward execute(
              ActionMapping mapping, ActionForm form,
              HttpServletRequest req, HttpServletResponse res) throws Exception {

		yswebSession mysess	 = yswebGetSession.get(req);
		int		counter	= 1;
		String	data	= null;

		sampleForm samForm  = (sampleForm)form;
		samEcho		echo	= new samEcho();

		if (mysess == null) {
			log.info("samEchoAction:execute() yswebSession null");
	        return mapping.findForward(samConst.ERROR);
		}
		data = samForm.getValue("input");
		if (data == null) data = "eXgf[^";
		else if (data.length() <= 0) data = "eXgf[^";

		String str	= samForm.getValue("counter");
		if ((str != null) && (str.length() > 0)) {
			counter = getInt(str);
		}
		if (counter < 1) counter = 1;

		counter = echo.execute(mysess, data, counter);
		samForm.setValue("input", data);
		samForm.setValue("counter", Integer.toString(counter));

        req.setAttribute("sampleForm", samForm);

		yswebGetSession.free(mysess);
        return mapping.findForward("result");
	}
	private int getInt(String str) {
		int		retint	= 0;
		try{
			retint = Integer.parseInt(str);
		}catch(Exception e) {
			retint = 0;
		}
		return retint;
	}
}
