/* samPrPrintAction: print process Action program				*/
/* Copyright (c) 2004-2005 yma system lab. All rights reserved.	*/

package action;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.commons.logging.*;

import action.form.*;
import model.*;
import yscsoltp.yswebsvr.*;

public class samPrPrintAction extends Action {
	private	Log 	 log	= LogFactory.getLog(getClass());

    public ActionForward execute(
              ActionMapping mapping, ActionForm form,
              HttpServletRequest req, HttpServletResponse res) throws Exception {

		yswebSession mysess	 = yswebGetSession.get(req);
		samPrPrint	 prprint = new samPrPrint();
		String		 pdffile = null;

		if (mysess == null) {
			log.error("samPrPrintAction:execute() yswebSession null");
	        return mapping.findForward(samConst.ERROR);
		}
		pdffile = prprint.prProcess(mysess);

		log.info(pdffile);
		yswebGetSession.free(mysess);
		if (pdffile == null) {
			return mapping.findForward(samConst.ERROR);
		}
		return (new ActionForward(pdffile, true));	/* pdf̕\	*/
	}
}
