/* samDbDisp: get user list from tbyscsuser					*/
/* Copyright (c) 2004-2005 yma system lab. All rights reserved.	*/
package model;
import org.apache.commons.logging.*;
import java.util.*;
import yscsoltp.yswebsvr.*;
import yscsoltp.ysapldata.*;

public class samDbDisp {
	private	Log 	 log	= LogFactory.getLog(getClass());

	public samDbDisp(){}

	public int dispPage(yswebSession mysess, String sql, int dispRecd) {
		int				retcode		= 0;
		int				skipCounts	= 0;

		ysadTblData tbldata = getTblData(mysess);
		if (tbldata == null) tbldata = new ysadTblData();

		if (sql != null) {				/* sqlnullȂݒς݂sql𗘗p	*/
			tbldata.setSqlText(sql);
			skipCounts = 0;
		}
		else skipCounts = tbldata.getSkipCounts();	/* XLbv擾		*/

		tbldata.setSkipCounts(skipCounts);			/* XLbvݒ		*/
		tbldata.setRecdCounts(dispRecd);			/* 擾R[hݒ	*/

		/* f[^x[XANZXFXLbvA擾R[hAsql		*/
		ysadTblData retdata = mysess.dbAccess(tbldata, tbldata.reqSelect);
		mysess.setValue("tblData", retdata);	/* Af[^\pɐݒ	*/

		if (retdata == null) log.info("tbldata null");
		else {
			if (retdata.getResult() != 0) {		/* G[̏ꍇ				*/
				retdata.setLast(true);			/* ŏIR[hݒ		*/
				retdata.setSkipCounts(0);		/* XLbvZbg		*/
				retcode = -1;
			}
		}
        return retcode;
	}

	public int nextPage(yswebSession mysess, int dispRecd) {	/* y[W	*/
		setSkipCounts(mysess, dispRecd);				/* XLbv𑝉	*/
		return dispPage(mysess, null, dispRecd);		/* R[h擾	*/
	}

	public int backPage(yswebSession mysess, int dispRecd) {	/* ߂		*/
		setSkipCounts(mysess, - dispRecd);				/* XLbv	*/
		return dispPage(mysess, null, dispRecd);		/* R[h擾	*/
	}

	private int setSkipCounts(yswebSession mysess, int counts) {
		int		retcode		= 0;

		ysadTblData tbldata = getTblData(mysess);
		if (tbldata != null) {
			int skipCounts = tbldata.getSkipCounts();
			skipCounts += counts;
			if (skipCounts < 0) skipCounts = 0;
			tbldata.setSkipCounts(skipCounts);
		}
		return retcode;
	}
	private ysadTblData getTblData(yswebSession mysess) {
		return  (ysadTblData)mysess.getValue("tblData");
	}
}
