/* samPage: sample program. set sample datas.					*/
/* Copyright (c) 2004-2005 yma system lab. All rights reserved.	*/
package model;
import java.util.*;

import org.apache.commons.logging.*;
import yscsoltp.yswebsvr.*;
import yscsoltp.ysapldata.*;

public class samPage implements yswebIntface {
	private	Log 	 log	= LogFactory.getLog(getClass());
	private static final int	rowCounts	= 5;
	private static final int	clmCounts	= 3;

	public samPage(){}

	public int execute(yswebSession mysess) {
		int				retcode		= 0;
		ysadTblData		tbldata 	= new ysadTblData();	/* \f[^p̈	*/
		List<String>	clmnames	= new ArrayList<String>();/* ږ̈		*/
		List<String>	clmsizes	= new ArrayList<String>();/* ڒ̈		*/
		List<List>		rowdatas	= new ArrayList<List>();/* sf[^̈		*/

		for(int i = 0; i < clmCounts; i++) {
			String	data = "" + i;
			clmnames.add(data);								/* ږݒ		*/
			int len = data.getBytes().length;
			clmsizes.add(Integer.toString(len));			/* ږݒ	*/
		}
		tbldata.setClmNames(clmnames);						/* ږ̈ݒ	*/
		tbldata.setClmSizes(clmsizes);						/* ږݒ	*/

		for(int i = 0; i < 5; i++) {						/* 5s̃f[^쐬	*/
			List<String> clmdatas = new ArrayList<String>();/* ڃf[^̈	*/

			for(int j = 0; j < 3; j++) {					/* 3ڂ̃f[^쐬*/
				String data = "eXgf[^-" + i + "." + j;
				clmdatas.add(data);							/* ڃf[^ݒ	*/
				int  datalen = data.getBytes().length;
				if (Integer.parseInt(clmsizes.get(j)) < datalen) {
					clmsizes.set(j, Integer.toString(datalen));/* f[^XV*/
				}
			}
			rowdatas.add(clmdatas);							/* sf[^ݒ	*/
		}
		tbldata.setRowDatas(rowdatas);						/* sf[^̈ݒ	*/
		mysess.setValue("tblData", tbldata);				/* \f[^ݒ	*/
		return retcode;
	}

	public int dispPage(yswebSession mysess, HashMap<String, String> map) {
		int			retcode		= 0;
		ysadTblData tbldata 	= getTblData(mysess);
		List<List>   updatas	= new ArrayList<List>();	/* XVf[^̈	*/

		int 		rowcounts	= tbldata.getRowDatas().size();
		int 		clmcounts	= tbldata.getClmSizes().size();

		for(int i = 0; i < rowcounts; i++) {
			List<String> clmdatas = new ArrayList<String>();

			for(int j = 0; j < clmcounts; j++) {
				String  key = "data" + i + "." + j;			/* f[^L[		*/
				String  value = (String)map.get(key);		/* ̓f[^擾	*/
				if (value == null) continue;
				clmdatas.add(value.trim());					/* f[^ݒ		*/
			}
			updatas.add(clmdatas);
		}
		tbldata.setUpdDatas(updatas);						/* XVf[^ݒ	*/
		return retcode;
	}

	private ysadTblData getTblData(yswebSession mysess) {
		return  (ysadTblData)mysess.getValue("tblData");
	}
}
